
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "io.h"

byte8 GL_reiniciar = FALSE;

void init(void)
{}

byte8 mostrar(char *graf,char *cadena,byte8 cont)
{
  mostrar_texto(cadena,cont);
  if (GL_reiniciar) { GL_reiniciar = FALSE; return FALSE; }
  return TRUE;
}

void mostrar_opciones(opc *opciones,byte8 orein)
{
  byte8 i;
  char aux[300];

  for (i = 0; opciones[i].topc[0]!='\0'; i++)
  {
    sprintf(aux,"%d - %s",i+1,opciones[i].topc);
    putsw(aux);
  }
  putchar('\n');
}

byte8 input(opc *opciones,byte8 nopciones,byte8 orein)
{
  char ent[13];
  int opcion = 0;

  for (;;)
  {
    fputs("Elige opcin ",stdout);
    if (orein)
      putsw("o \"reiniciar\" el juego o \"releer\" las ltimas descripciones o bien \"salir\"");
    else
      putchar('\n');
    putchar('>');
    fgets(ent,11,stdin);
    putchar('\n');
    if (orein)
    {
      if (!strcmp(ent,"reiniciar\n")) return I_REINI;
      if (!strcmp(ent,"releer\n")) return I_REVER;
      if (!strcmp(ent,"salir\n")) exit(0);
    }
    opcion = atoi(ent);
    if (opcion>0 && opcion<=nopciones) return opcion-1;
  }
}

void terminar(void)
{
  exit(0);
}

void mostrar_texto(char *cadena,byte8 cont)
{
  if (inicio(cadena))
  {
    puts(cadena);
    puts("WrapText.c version 1, Copyright (C) 2006 Michael D Henderson, bajo LGPL");
  }
  else putsw(cadena);
  putchar('\n');

  switch (cont)
  {
    case TRUE:
      continuar("\0");
      break;
    case FALSE:
      continuar("[Opciones]");
      break;
    case FIN:
      continuar("Fin\n\n[Continuar]");
      break;
    case INI:
      continuar("[Empezar]");
  }
}


void continuar(char *t)
{
  char aux[30] = "[Continuar]", ent[13];
  byte8 orein = FALSE;

  if (t[0]!='\0') strcpy(aux,t);
  fputs(aux,stdout);
  if (strcmp(t,"Fin\n\n[Continuar]") && strcmp(t,"[Empezar]"))
  {
    puts(wt(", \"reiniciar\" o \"salir\"",ANCHO-9));
    orein = TRUE;
  }
  else putchar('\n');
  putchar('>');
  fgets(ent,11,stdin);
  putchar('\n');
  if (orein)
  {
    if (!strcmp(ent,"reiniciar\n")) GL_reiniciar = TRUE;
    if (!strcmp(ent,"salir\n")) exit(0);
  }
}

byte8 inicio(char *cadena)
{
  if (cadena[0]=='P' && cadena[1]=='A' && cadena[2]=='E') return TRUE;
  else return FALSE;
}

void putsw(char *cadena)
{
  puts(wt(cadena,ANCHO));
}

char *wt(char *cadena,int ancho)
{
#ifndef NO_WRAP
  return WrapText(cadena,ancho,"","");
#endif
}
